Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class ForExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.Assignation
              net.sf.saxon.expr.ForExpression

All Implemented Interfaces:
  Serializable, SourceLocator, Binding, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public class ForExpression

extends Assignation

A ForExpression maps an expression over a sequence. This version works with range variables, it doesn't change the context information

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ForExpression()`

Method Summary
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`int` | `computeCardinality()` Determine the static cardinality of the expression
`Expression` | `convertWhereToPredicate(Optimizer opt, StaticContext env, ItemType contextItemType)` Convert where clause, if possible, to a predicate.
`void` | `display(int level, PrintStream out, Configuration config)` Diagnostic print of expression structure
`int` | `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items returned by the expression, if possible
`int` | `getPositionVariableNameCode()`
`int` | `getRequiredSlots()` Get the number of slots required.
`SequenceIterator` | `iterate(XPathContext context)` Iterate over the sequence of values
`int` | `markTailFunctionCalls(int nameCode, int arity)` Mark tail function calls: only possible if the for expression iterates zero or one times.
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Optimize the expression
`void` | `process(XPathContext context)` Process this expression as an instruction, writing results to the current outputter
`void` | `setAction(Expression action)` Add the "return" or "satisfies" expression, and fix up all references to the range variable that occur within that expression
`void` | `setPositionVariable(RangeVariableDeclaration decl)` Set the reference to the position variable (XQuery only)
`void` | `setSlotNumber(int nr)` Set the slot number for the range variable
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.Assignation
`evaluateVariable, getAction, getLocalSlotNumber, getSequence, getVariableDeclaration, getVariableFingerprint, getVariableName, getVariableNameCode, isAssignable, isGlobal, iterateSubExpressions, promote, replaceSubExpression, setSequence, setVariableDeclaration, simplify, suppressValidation`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, computeDependencies, computeSpecialProperties, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, resetStaticProperties, setLocationId, setParentExpression, setParentExpression`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ForExpression

    public ForExpression()

Method Detail

### setPositionVariable

    public void setPositionVariable(RangeVariableDeclaration decl)

  Set the reference to the position variable (XQuery only)

### getPositionVariableNameCode

    public int getPositionVariableNameCode()

### setAction

    public void setAction(Expression action)

  Description copied from class: `Assignation`
  Add the "return" or "satisfies" expression, and fix up all references to the range variable that occur within that expression

  Overrides:
    `setAction` in class `Assignation`
  Parameters:
    `action` - the expression that occurs after the "return" keyword of a "for" expression, the "satisfies" keyword of "some/every", or the ":=" operator of a "let" expression.

    This method must be called after calling setVariableDeclaration()

### setSlotNumber

    public void setSlotNumber(int nr)

  Set the slot number for the range variable

  Overrides:
    `setSlotNumber` in class `Assignation`

### getRequiredSlots

    public int getRequiredSlots()

  Get the number of slots required. Normally 1, except for a FOR expression with an AT clause, where it is 2.

  Overrides:
    `getRequiredSlots` in class `Assignation`

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Optimize the expression

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### convertWhereToPredicate

    public Expression convertWhereToPredicate(Optimizer opt,
                                              StaticContext env,
                                              ItemType contextItemType)
                                       throws XPathException

  Convert where clause, if possible, to a predicate. Returns the converted expression if modified, or null otherwise

  Throws:
    `XPathException`

### markTailFunctionCalls

    public int markTailFunctionCalls(int nameCode,
                                     int arity)

  Mark tail function calls: only possible if the for expression iterates zero or one times. (This arises in XSLT/XPath, which does not have a LET expression, so FOR gets used instead)

  Overrides:
    `markTailFunctionCalls` in class `Expression`
  Returns:
    0 if no tail call was found; 1 if a tail call on a different function was found; 2 if a tail recursive call was found and if this call accounts for the whole of the value.

### getImplementationMethod

    public int getImplementationMethod()

  An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided. This implementation provides both iterate() and process() methods natively.

  Overrides:
    `getImplementationMethod` in class `Expression`

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Overrides:
    `checkPermittedContents` in class `Expression`
  Throws:
    `XPathException`

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the sequence of values

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### process

    public void process(XPathContext context)
                 throws XPathException

  Process this expression as an instruction, writing results to the current outputter

  Overrides:
    `process` in class `Expression`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by the expression, if possible

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` -
  Returns:
    one of the values Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known in advance)

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Diagnostic print of expression structure

  Specified by:
    `display` in class `Expression`
  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.